#ifndef _CONST_H_
#define _CONST_H_

#include <cmath>

#define NO_UE  -1
#define MIN(x,y) (((x)<=(y))?(x):(y))
#define MAX(x,y) (((x)>=(y))?(x):(y))
#define dB2linear(x) (pow(10.0,x/10.0))
#define dBm2linear(x) (pow(10.0, (x- 30)/10.0))
#define linear2dB(x) (10*log10(x))
#define linear2dBm(x) (10*log10(x * 1000 ))
const double PI = 4 * atan(1.);
const double SPEED_LIGHT = 300000000.;


enum test_environment_TYPE
{
	InH_eMBB_A, InH_eMBB_B, InH_eMBB_C,
	Dense_Urban_eMBB_A, Dense_Urban_eMBB_B, Dense_Urban_eMBB_C_Macro, Dense_Urban_eMBB_C_Micro,
	Rural_eMBB_A, Rural_eMBB_B, Rural_eMBB_C
};

enum pathloss_model_TYPE
{
	InH_A, InH_B,
	UMa_A, UMa_B,
	UMi_A, UMi_B,
	RMa_A, RMa_B
};


enum UE_LOCATION
{
	INDOOR, IN_CAR, PEDESTRIAN

};

enum LOS_TLSP
{
	LOS_SF, LOS_K,LOS_DS, LOS_ASD, LOS_ASA, LOS_ZSD, LOS_ZSA
};

enum NLOS_TLSP
{
	NLOS_SF, NLOS_DS, NLOS_ASD, NLOS_ASA, NLOS_ZSD, NLOS_ZSA
};

enum OUT2IN_TLSP
{
	OUT2IN_SF, OUT2IN_DS, OUT2IN_ASD, OUT2IN_ASA, OUT2IN_ZSD, OUT2IN_ZSA
};

enum propagation_condition
{
	LOS, NLOS, OUT2IN
};

enum distribution
{
	Laplacian, Wrapped_Gaussian
};

#endif

#pragma once