#include "paramSimul.h"
#include "objectBSSectorUe.h"
#include "evaluationConfigurerations.h"
#include <fstream>
#include <iostream>
using namespace std;


void Deploy_UMi_site(int sector_idx);
void Deploy_ue_in_layout();

void Deploy_bs_ue()
{
	if (test_environment == Dense_Urban_eMBB_C_Micro)
	{
		for (int bs_idx = 0; bs_idx < num_bs; bs_idx++)
		{
			Deploy_UMi_site(bs_idx);
		}
	}
	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
	{
		ue[ue_idx].Drop_ue_in_cell();
	}
	Deploy_ue_in_layout();


	if (calibration == 1)
	{
		for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
		{
			for (int bs_idx = 0; bs_idx < num_bs; bs_idx++)
			{
				ue[ue_idx]._2D_distance[bs_idx] = 1000;
			}
		}
	}
 	
}


void Deploy_UMi_site(int bs_idx)
{
	
	double distance_bt_bs[3];
	bool a;
	
	for (int bs_idx = 0; bs_idx < num_bs; bs_idx++)
	{
		do
		{
			bs[bs_idx].Deploy_UMi_site();
			bs_idx++;
			bs[bs_idx].Deploy_UMi_site();
			bs_idx++;
			bs[bs_idx].Deploy_UMi_site();

			distance_bt_bs[0] = pow(pow(bs[bs_idx].location.x - bs[bs_idx - 1].location.x, 2) + pow(bs[bs_idx].location.y - bs[bs_idx - 1].location.y, 2), 0.5);
			distance_bt_bs[1] = pow(pow(bs[bs_idx].location.x - bs[bs_idx - 2].location.x, 2) + pow(bs[bs_idx].location.y - bs[bs_idx - 2].location.y, 2), 0.5);
			distance_bt_bs[2] = pow(pow(bs[bs_idx - 2].location.x - bs[bs_idx - 1].location.x, 2) + pow(bs[bs_idx - 2].location.y - bs[bs_idx - 1].location.y, 2), 0.5);

			a = (distance_bt_bs[0] < micro_min_inter_site_distance) || (distance_bt_bs[1] < micro_min_inter_site_distance) || (distance_bt_bs[2] < micro_min_inter_site_distance);
			if (a == 1)
			{
				bs_idx = bs_idx - 2;
			}

		} while (a);
	}

	for (int bs_idx = 0; bs_idx < num_bs; bs_idx++)
	{
		if ((bs_idx % 9) / 3 < 1)
		{
			bs[bs_idx].location.x -= inter_site_distance/ pow(3, 0.5) / pow(3, 0.5);

		}
		else if ((bs_idx % 9) / 3 < 2)
		{
			bs[bs_idx].location.x += inter_site_distance/ pow(3, 0.5)*pow(3, 0.5) / 6;
			bs[bs_idx].location.y += inter_site_distance/ pow(3, 0.5) / 2.;

		}
		else
		{
			bs[bs_idx].location.x += inter_site_distance / pow(3, 0.5)*pow(3, 0.5) / 6;
			bs[bs_idx].location.y -= inter_site_distance / pow(3, 0.5) / 2.;
		}
	}
	
}

void Deploy_ue_in_layout()
{
	
	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
	{
		if (test_environment < 3)
		{
			double distance_x, distance_y;


			ue[ue_idx].pos_in_cell.x = (int)(3. * Rand.u())*20. + ue[ue_idx].pos_in_cell.x;

			if (Rand.u() > 0.5)
			{
				ue[ue_idx].pos_indoor.x = -ue[ue_idx].pos_in_cell.x;
			}

			if (Rand.u() > 0.5)
			{
				ue[ue_idx].pos_indoor.y = -ue[ue_idx].pos_in_cell.y;
			}


			for (int bs_idx = 0; bs_idx < num_bs; bs_idx++)
			{

				if (bs_idx < 6)
				{
					distance_x = ue[ue_idx].pos_in_cell.x - (-50. + bs_idx *20.);
					distance_y = ue[ue_idx].pos_in_cell.y - 10;
				}
				else
				{
					distance_x = ue[ue_idx].pos_in_cell.x - (-50. + (bs_idx - 6) *20.);
					distance_y = ue[ue_idx].pos_in_cell.y + 10;
				}
				
				ue[ue_idx]._2D_distance[bs_idx] = pow((distance_x * distance_x + distance_y * distance_y), 0.5);

			}
		}
		else if (test_environment == Dense_Urban_eMBB_C_Micro)
		{
			int  my_Micro_BS = (int)(num_bs * Rand.u());
			int  my_Macro_BS = (int)(19);

			int Macro_BS_num;
			int Macro_bs_idx = 0;

			double UE_x, UE_y;
			double BS_x, BS_y;
			double distance_x, distance_y;

			UE_x = ue[ue_idx].pos_in_cell.x + bs[my_Micro_BS].location.x;
			UE_y = ue[ue_idx].pos_in_cell.y + bs[my_Micro_BS].location.y;

			for (int height = 0; height < 5; height++)
			{
				int vert = 2 - height;
				int num_horiz = 5 - abs(vert);
				for (int horiz = 0; horiz < num_horiz; horiz++)
				{
					
					Macro_BS_num = wrap[my_Macro_BS][Macro_bs_idx];

					ue[ue_idx].pos[Macro_BS_num].x = UE_x - (horiz - 2. + 0.5 * abs(vert)) * inter_site_distance;
					ue[ue_idx].pos[Macro_BS_num].y = UE_y - vert * sqrt(3.0) * inter_site_distance / 2.;


					for (int micro_bs_idx = 0; micro_bs_idx < 9; micro_bs_idx++)
					{
						BS_x = (horiz - 2. + 0.5 * abs(vert)) * inter_site_distance + bs[micro_bs_idx + 9 * Macro_BS_num].location.x;
						BS_y = vert * sqrt(3.0) * inter_site_distance / 2. + bs[micro_bs_idx + 9 * Macro_BS_num].location.y;

						distance_x = UE_x - BS_x;
						distance_y = UE_y - BS_y;

						ue[ue_idx]._2D_distance[micro_bs_idx + 9 * Macro_BS_num] = sqrt(distance_x * distance_x + distance_y * distance_y);
					}
					Macro_bs_idx++;
				}
			}
		}
		else
		{
			ue[ue_idx].mycell = (int)(19. * Rand.u());
			int bs_idx = 0;
			int BS_num;
			double x;
			double y;

			for (int height = 0; height < 5; height++)
			{
				int vert = 2 - height;
				int num_horiz = 5 - abs(vert);
				for (int horiz = 0; horiz < num_horiz; horiz++)
				{
					BS_num = wrap[ue[ue_idx].mycell][bs_idx];
					
					x = ue[ue_idx].pos_in_cell.x - (horiz - 2. + 0.5 * abs(vert)) * inter_site_distance;
					y = ue[ue_idx].pos_in_cell.y - vert * sqrt(3.0) * inter_site_distance / 2.;

					ue[ue_idx].pos[BS_num].x = cos(PI / 2.)*x - sin(PI / 2)*y;
					ue[ue_idx].pos[BS_num].y = sin(PI / 2.)*x + cos(PI / 2)*y;

					/*
					if (BS_num ==0)
					{
						cout << ue[ue_idx].pos[BS_num].y << endl;
					}
					*/

					ue[ue_idx]._2D_distance[BS_num] = sqrt(ue[ue_idx].pos[BS_num].x*ue[ue_idx].pos[BS_num].x + ue[ue_idx].pos[BS_num].y*ue[ue_idx].pos[BS_num].y);
					
					//ue[ue_idx].ue2sector_azimuth_angle[3 * BS_num] = atan2(ue[ue_idx].pos[BS_num].y, ue[ue_idx].pos[BS_num].x) * 180. / PI;
					
					
					bs_idx++;
				}
			}
		}
	}

	//getchar();

}