#include <stdio.h>
#include <iostream>
#include <fstream>
#include <time.h>
#include "paramSimul.h"
#include "ue.h"
#include "objectBSSectorUe.h"


#include <Eigen/Dense>

using namespace Eigen;

void Set_simul_param(int argc, char *argv[]);
void Make_ue_sector_object(void);
void Set_test_environment(void);
void Set_fastfading_param();
void Deploy_bs_ue(void);
void Configure_sector_ue(void);
void Calculate_UE_Sector_angle(void);
void Calculate_antenna_gain(void);
void Generate_pathloss(void);
void Get_Couplingloss_CDF(void);
void Connect_UE_BS(void);
void Collect_Couplingloss(void);
void Allocate_memory(void);
void Delete_memory(void);
void Generate_LSP(void);
void Generate_SSP(void);


int main(int argc, char *argv[])
{
	Set_simul_param(argc, argv);
	Make_ue_sector_object();
	Set_test_environment();
	Set_fastfading_param();
	Allocate_memory();

	for (drop_idx = 0; drop_idx < num_drops; drop_idx++)
	{
		cout << "drop_idx : " << drop_idx <<"/"<<num_drops<< endl;
		
		Configure_sector_ue();
		Deploy_bs_ue();
		Calculate_UE_Sector_angle();
		Calculate_antenna_gain();
		Generate_pathloss();
		
		cout << "Generate_LSP..." << endl;
		
		Generate_LSP();
		Connect_UE_BS();
		//Collect_Couplingloss();
		for (t = 0; t < run_times; t++)
		{
			Generate_SSP();
		}


	}

	//Get_Couplingloss_CDF();
	Delete_memory();
	
}

