#include <iostream>
#include "paramSimul.h"
#include "evaluationConfigurerations.h"
#include "const.h"
#include <complex>


using namespace std;


void Set_test_environment()
{
	cout << endl;
	cout << "---------test_environment------------" << endl;

	if (test_environment == InH_eMBB_A)
	{
		carrier_freq = 4 * 1000000000.;
		inter_site_distance = 20;
		indoor_ue_speed = 3;//km/h
		h_BS = 3;
		bs_noise_figure = 5; //dB
		ue_noise_figure = 7; //dB
		bs_antenna_element_gain = 5;//dBi
		ue_antenna_element_gain = 0;//dBi
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 10000000;// for FDD
		num_floor = 1;
		num_propagation_condition = 2; // LOS / NLOS
	}
	else if (test_environment == InH_eMBB_B)
	{
		carrier_freq = 30 * 1000000000.;
		inter_site_distance = 20;
		secter_to_ue_min_distance = 1;
		indoor_ue_speed = 3;//km/h
		h_BS = 3;
		bs_noise_figure = 7; //dB
		ue_noise_figure = 10; //dB
		bs_antenna_element_gain = 5;//dBi
		ue_antenna_element_gain = 5;//dBi
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 40000000;// for FDD
		num_floor = 1;
		num_propagation_condition = 2;
	
	}
	else if (test_environment == InH_eMBB_C)
	{
		carrier_freq = 70 * 1000000000.;
		inter_site_distance = 20;
		secter_to_ue_min_distance = 1;
		indoor_ue_speed = 3;//km/h
		h_BS = 3;
		bs_noise_figure = 7; //dB
		ue_noise_figure = 10; //dB
		bs_antenna_element_gain = 5;//dBi
		ue_antenna_element_gain = 5;//dBi
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 40000000;// for FDD
		num_floor = 1;
		num_propagation_condition = 2;
	}
	else if (test_environment == Dense_Urban_eMBB_A)
	{
		carrier_freq = 4 * 1000000000.;
		h_BS = 25;
		high_loss_type_portion = 0.2;
		indoor_ue_portion = 0.8;
		inter_site_distance = 200;
		secter_to_ue_min_distance = 10;
		indoor_ue_speed = 3;//km/h
		outdoor_ue_car_speed = 30;//km/h
		bs_noise_figure = 5; //dB
		ue_noise_figure = 7; //dB
		bs_antenna_element_gain = 8;//dBi
		ue_antenna_element_gain = 0;//dBi
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 10000000;// for FDD
		num_floor = 8;
		num_propagation_condition = 3;

	}

	else if (test_environment == Dense_Urban_eMBB_B)
	{
		carrier_freq = 30 * 1000000000.;
		h_BS = 25;
		high_loss_type_portion = 0.2;
		indoor_ue_portion = 0.8;
		inter_site_distance = 200;
		secter_to_ue_min_distance = 10;
		indoor_ue_speed = 3;//km/h
		outdoor_ue_car_speed = 30;//km/h
		bs_noise_figure = 7; //dB
		ue_noise_figure =10; //dB
		bs_antenna_element_gain = 8;//dBi
		ue_antenna_element_gain = 5;//dBi
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 40000000;// for FDD
		num_floor = 8;
		num_propagation_condition = 3;
	}
	else if (test_environment == Dense_Urban_eMBB_C_Macro)
	{
		carrier_freq = 4 * 1000000000.;
		h_BS = 25;
		high_loss_type_portion = 0.2;
		indoor_ue_portion = 0.8;
		inter_site_distance = 200;
		secter_to_ue_min_distance = 10;
		indoor_ue_speed = 3;//km/h
		outdoor_ue_car_speed = 30;//km/h
		bs_noise_figure = 5; //dB
		ue_noise_figure = 7; //dB
		bs_antenna_element_gain = 8;//dBi
		ue_antenna_element_gain = 0;//dBi
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 10000000;// for FDD
		num_floor = 8;
		num_propagation_condition = 3;
	}
	else if (test_environment == Dense_Urban_eMBB_C_Micro)
	{
		carrier_freq = 30 * 1000000000.;
		h_BS = 10;
		high_loss_type_portion = 0.2;
		indoor_ue_portion = 0.8;
		inter_site_distance = 200; 
		secter_to_ue_min_distance = 0;
		micro_min_inter_site_distance = 30;
		micro_cell_radius = 25;
		indoor_ue_speed = 3;//km/h
		outdoor_ue_car_speed = 30;//km/h
		bs_noise_figure = 7; //dB
		ue_noise_figure =10; //dB
		bs_antenna_element_gain = 8;//dBi
		ue_antenna_element_gain = 5;//dBi
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 40000000;// for FDD
		num_floor = 8;
		num_propagation_condition = 3;
	}
	else if (test_environment == Rural_eMBB_A)
	{
		carrier_freq = 0.7* 1000000000.;
		h_BS = 35;
		high_loss_type_portion = 0;
		indoor_ue_portion = 0.5;
		inter_site_distance = 1732; //Macro
		secter_to_ue_min_distance = 0;
		indoor_ue_speed = 3;//km/h
		outdoor_ue_car_speed = 120;//km/h
		bs_noise_figure = 5; //dB
		ue_noise_figure = 7; //dB
		bs_antenna_element_gain = 8;//dBi
		ue_antenna_element_gain = 0;//dBi
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 10000000;// for FDD
		num_floor = 1;
		num_propagation_condition = 3;
	}
	else if (test_environment == Rural_eMBB_B)
	{
		carrier_freq = 4* 1000000000.;
		h_BS = 35;
		high_loss_type_portion = 0;
		indoor_ue_portion = 0.5;
		inter_site_distance = 1732; //Macro
		secter_to_ue_min_distance = 0;
		indoor_ue_speed = 3;//km/h
		outdoor_ue_car_speed = 120;//km/h
		bs_noise_figure = 5; //dB
		ue_noise_figure = 7; //dB
		bs_antenna_element_gain = 8;//dBi
		ue_antenna_element_gain = 0;//dBi
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 10000000;// for FDD
		num_floor = 1;
		num_propagation_condition = 3;
	}
	else if (test_environment == Rural_eMBB_C)
	{
		carrier_freq = 0.7 * 1000000000.;
		h_BS = 35;
		high_loss_type_portion = 0;
		indoor_ue_portion = 0.4;
		outdoor_pedestrian_portion = 0.4;
		inter_site_distance = 6000; //Macro
		secter_to_ue_min_distance = 0;
		indoor_ue_speed = 3;//km/h
		outdoor_ue_car_speed = 120;//km/h
		outdoor_ue_pedestrian_speed = 3; //km/h
		bs_noise_figure = 5; //dB
		ue_noise_figure = 7; //dB
		bs_antenna_element_gain = 8;//dBi
		ue_antenna_element_gain = 0;//dBi
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 10000000;// for FDD
		num_floor = 1;
		num_propagation_condition = 3;
	}



	if (pathloss_model == UMa_A ) //table 3-4
	{
		W = 20, h = 20;
	}
	else if (pathloss_model == RMa_A || pathloss_model == RMa_B)
	{
		W = 20, h = 5;
	}
	
	lamda_0 =  SPEED_LIGHT/carrier_freq;

	L_glass = 2. + 0.2*carrier_freq / 1000000000.;
	L_IRRglass = 23. + 0.3*carrier_freq / 1000000000.;
	L_concrete = 5. + 4.*carrier_freq / 1000000000.;
	L_wood = 4.85 + 0.12*carrier_freq / 1000000000.;

	Low_loss_model = 5. - 10.*log10(0.3 * pow(10., -L_glass / 10) + 0.7*pow(10., -L_concrete / 10));
	High_loss_model = 5. - 10.*log10(0.7 * pow(10., -L_IRRglass / 10) + 0.3*pow(10., -L_concrete / 10));
	
	Low_loss_model_std = 4.4;
	High_loss_model_std = 6.5;

	car_penet_loss_mean = 9;
	car_penet_loss_std = 5;

	cout << "carrier_freq              : " << carrier_freq << endl;
	cout << "wavelength                : " << lamda_0 << endl;
	cout << "inter_site_distance       : " << inter_site_distance << endl;
	cout << "secter_to_ue_min_distance : " << secter_to_ue_min_distance << endl;
	cout << "indoor_ue_speed           : " << indoor_ue_speed << endl;
	cout << "h_BS                      : " << h_BS << endl;
	cout << "bs_noise_figure           : " << bs_noise_figure << endl;
	cout << "ue_noise_figure           : " << ue_noise_figure << endl;
	cout << "bs_antenna_element_gain   : " << bs_antenna_element_gain << endl;
	cout << "ue_antenna_element_gain   : " << ue_antenna_element_gain << endl;
	cout << "thermal_nosie_level       : " << thermal_nosie_level << endl;
	cout << "simulation_bandwidth      : " << simulation_bandwidth << endl;
	
}